/**
  *  \file t_call.cc
  *
  *  (c) 2001-2009 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */

#include "cpluslib/call.h"
#include "cpluslib/format.h"
#include "cpluslib/string.h"

#include "tests.h"

namespace {
    string_t foo(Callable2<int, int, int> f)
    {
        return format("f(1,2) = %d, f(10,5) = %d")
            << f(1, 2)
            << f(10,5);
    }

    int add(int a, int b)
    {
        return a+b;
    }

    int mult(int a, int b)
    {
        return a*b;
    }

    struct Adder {
        int x;
        int blub(int a, int b) { return x+a+b; }
        Adder(int xx) : x(xx) { }
    };
}

void
TestCall::testCall()
{
    Adder a(9);
    TS_ASSERT_EQUALS(foo(add),  "f(1,2) = 3, f(10,5) = 15");
    TS_ASSERT_EQUALS(foo(mult), "f(1,2) = 2, f(10,5) = 50");
    TS_ASSERT_EQUALS(foo(makeCallable(a, &Adder::blub)), "f(1,2) = 12, f(10,5) = 24");
}
